use <OnlyBatteryHolder.scad>;
use <TP4056Holder.scad>;

numOfPlayers = 6;
height = 3;
$fn = 128;

difference() {
    translate([0,0,-25])
    union() {
        cylinder(r=50, h=25);
        for (i = [1 : numOfPlayers]) {
            s = 65;
            frac = 360/numOfPlayers;

            rotate([0, 0, frac * i])
            translate([s, 0, 0])
            difference() {
                cylinder(r=35, h=25);
            }
        }
    }
    
    translate([0,0,-23])
    union() {
        cylinder(r=65, h=25);
        for (i = [1 : numOfPlayers]) {
            s = 65;
            frac = 360/numOfPlayers;

            rotate([0, 0, frac * i])
            translate([s, 0, 0])
            difference() {
                cylinder(r=33, h=25);
            }
        }
    }

    // hole for micro-usb
    translate([-100, -15.5, -19])
    cube([8, 4, 10]);
}

// tp4056 / power connector
translate([-98, -12, -25])
tp4056Holder();
// connect holder to wall
translate([-97, -10.5, -23])
cube([2, 1.5, 14.5]);

// LED podests
translate([0,0,-23])
for (i = [1 : numOfPlayers]) {
    s = 65;
    frac = 360/numOfPlayers;
    rotate([0, 0, frac * i])
    translate([s, 0, 0])
    difference() {
        rotate([0, 0, 45])
        cylinder(20,15,12,$fn=4);
        
        cylinder(20,13);
    }
}

// batteries
translate([0, 2, -24])
batteryHolder();

// ESP32-box
translate([-30, -35, -23])
difference() {
    cube([60, 30, 10]);
    
    translate([1.5, 1, 0])
    cube([57, 28, 11]);
}