module batteryHolder() {
    batteryLength = 65;
    batteryDiameter = 18.5;
    numOfBatteries = 2;
    
    // length
    innerLength = batteryLength + 2; // 2mm for spring
    outerLength = innerLength + 2*3; // 3mm per side for clips
    
    // width
    innerWidth = batteryDiameter + 0.5; // some buffer
    outerWidth = innerWidth + 2; // 1mm border on each side
    
    // height
    floorHeight = 1;
    height = batteryDiameter + 0.5 + floorHeight; // some buffer + floor
    
    // origin = left center
    module clipHolder() {
        clipWidth = 11;
        clipLR = 2;
        clipDepth = 1;
        translate([clipDepth/2, 0, 0])
        union() {
            cube([clipDepth, clipWidth+1, height], center=true);
            translate([(2+clipDepth)/2, 0, 0])
            cube([2, clipWidth - 2*clipLR, height], center=true);
        }
    }
    
    module singleBat() {
        difference() {
            translate([-outerLength/2, 0, 0])
            difference() {
                cube([outerLength, outerWidth, height]);
                    
                translate([3, 1, floorHeight])
                cube([innerLength, innerWidth, height]);
            }
    
            // left clip
            translate([-outerLength/2+1, innerWidth/2+1, height/2 + floorHeight + 3])
            clipHolder();
    
            // right clip
            translate([outerLength/2-1, innerWidth/2+1, height/2 + floorHeight + 3])
            rotate([0, 0, 180])
            clipHolder();
        
            // lowering sides for taking batteries out
            translate([0, 0, 41.5])
            rotate([90, 0, 0])
            cylinder(d=innerLength*1.25, h=100, center=true, $fn=6);
            
            // lowering sides for taking batteries out (other variant)
            //translate([0, 0, 41.5])
            //rotate([90, 0, 0])
            //cylinder(d=innerLength, h=100, center=true);
            
            // gabs in floor
            translate([-30, 5, -0.5])
            cube([60, 11, 3]);    
            translate([-30, 24, -0.5])
            cube([60, 11, 3]);
        }
    }
    
    for (i = [0 : numOfBatteries-1]) {
        translate([0, (outerWidth-1)*i, 0])
        singleBat();
    }
}